/*
 * Copyright (c) 2004 Nokia
 * Licensed under GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#define SCRATCHBOX_CONFIG "/targets/links/scratchbox.config"
#define GCC_WRAPPER_PATH  "/scratchbox/compilers/bin/sb_gcc_wrapper"

int main(int argc, char **argv)
{
	char *name;
	FILE *file;
	char buf[1024];

	name = getenv("SBOX_SCRATCHBOX_CONFIG");
	if (name == NULL)
		name = SCRATCHBOX_CONFIG;

	if ((file = fopen(name, "r")) == NULL) {
		fprintf(stderr, "sb_i386_wrapper: Unable to open %s\n", name);
		return 1;
	}

	do {
		if (fgets(buf, sizeof (buf) - 1, file) == NULL) {
			fprintf(stderr, "sb_i386_wrapper: Unable to read %s\n", name);
			return 1;
		}
	} while (strncmp(buf, "SBOX_CPU=", 9) != 0);

	fclose(file);

	if (strncmp(buf + 9, "i686", 4) == 0) {
		char *p;

		p = strrchr(argv[0], '/');
		if (p)
			++p;
		else
			p = argv[0];

		if (strncmp(p, "i386-", 5) == 0)
			p[1] = '6';
	}

	execvp(GCC_WRAPPER_PATH, argv);
	fprintf(stderr, GCC_WRAPPER_PATH" %s: %s", argv[0], strerror(errno));
	return 1;
}
